#pragma once

class MorseCode final
{
  public:
    MorseCode();
    void sendCharacter(const char ch);
    bool charToMorse(const unsigned char ch, char *morseSymbols);

  private:
    void buildMap();
    const char *morseMap[256] {nullptr};
    static constexpr const char *morseTable[] = {
        ".-..-.",  // " => <RR>
        "...-..-", // $ => <SX>
        ".----.",  // ' => <WG>
        "-.--.",   // ( => <KN>
        "-.--.-",  // ) => <KK>
        ".-.-.",   // + => <AR>
        "--..--",  // ,
        "-....-",  // - => <DU>
        ".-.-.-",  // .
        "-..-.",   // / => <DN>
        "-----",   // 0
        ".----",   // 1
        "..---",   // 2
        "...--",   // 3
        "....-",   // 4
        ".....",   // 5
        "-....",   // 6
        "--...",   // 7
        "---..",   // 8
        "----.",   // 9
        "-.--.",   // : => <KN>
        ".-.-",    // ; => <AA>
        ".-.-.",   // < => <AR> [sic!]
        "-...-",   // = => <BT>
        "...-.-",  // > == <SK>
        "..--..",  // ?
        ".--.-.",  // @ => <AC>
        ".-",      // A
        "-...",    // B
        "-.-.",    // C
        "-..",     // D
        ".",       // E
        "..-.",    // F
        "--.",     // G
        "....",    // H
        "..",      // I
        ".---",    // J
        "-.-",     // K
        ".-..",    // L
        "--",      // M
        "-.",      // N
        "---",     // O
        ".--.",    // P
        "--.-",    // Q
        ".-.",     // R
        "...",     // S
        "-",       // T
        "..-",     // U
        "...-",    // V
        ".--",     // W
        "-..-",    // X
        "-.--",    // Y
        "--..",    // Z
        ".-...",   // [ => <AS>
        "-..-.",   // \ => <DN>
        "-.--.",   // ] => <KN> [sic!]
    };
};