#pragma once

#include <hardware/clocks.h>

#include <tm1637.pio.h>

#include "settings.h"

class TM1637
{
  public:
    TM1637(uint8_t dio, uint8_t clk, PIO pio);
    void setColon(bool on);
    void displayIambicMode(Mode iambic);
    void displaySpeed(uint8_t speed);

  private:
    void init(uint8_t dio, uint8_t clk);
    void setClockDivider();
    void send4Bytes(uint32_t data);

    PIO m_pio {};
    uint8_t m_stateMachine {};
    pio_sm_config m_stateMachineConfig {};
    uint8_t m_brightness {0};
    uint32_t m_currentSegments {0};
    bool m_isColon {false};
    static constexpr uint8_t BYTE_SIZE = 8;
    static constexpr uint8_t WRITE_MODE = 0x40;
    static constexpr uint8_t WRITE_ADDRESS = 0xC0;
    static constexpr uint8_t BRIGHTNESS_BASE = 0x88;
};